structure PhaseSplitTop :> PHASE_SPLIT_TOP =
  struct
    structure PhaseSplit :> PHASE_SPLIT = PhaseSplit

    fun process_program split input_to_layout output_to_layout input =
        let val output = split input
            val layout =
                Layout.align
                    [ Layout.seq [Layout.str "  |- ",
                                  input_to_layout input],
                      Layout.seq [Layout.str " ~~> ",
                                  output_to_layout output] ]
            (* weird... it seems to go over if you allow the default of 80 *)
            val s = Layout.tostringex 77 layout
        in
            print (s ^ "\n")
        (*
        in
            Layout.print (layout, print);
            print "\n"
        *)
        end
        handle
            PhaseSplit.Split string =>
                print ("Phase splitting error: " ^ string ^ "\n")
          | PhaseSplit.Error string =>
                print ("Phase splitting internal error: " ^ string ^ "\n")
          | IL1Static.Check string =>
                print ("IL type error: " ^ string ^ "\n")
          | IL1Static.Error string =>
                print ("IL internal error: " ^ string ^ "\n")

    val split_module =
        process_program
            PhaseSplit.split_module
            IL1Print.module_to_layout
            IL2Print.module_to_layout
    val split_signat =
        process_program
            PhaseSplit.split_signat
            IL1Print.signat_to_layout
            IL2Print.signat_to_layout
    val split_exp =
        process_program
            PhaseSplit.split_exp
            IL1Print.exp_to_layout
            IL2Print.exp_to_layout
    val split_con =
        process_program
            PhaseSplit.split_con
            IL1Print.con_to_layout
            IL2Print.con_to_layout
    val split_kind =
        process_program
            PhaseSplit.split_kind
            IL1Print.kind_to_layout
            IL2Print.kind_to_layout
  end
