signature IL1CONTEXT =
  sig
    type context
    type label = IL1.label

    val empty : context
    val extend : context -> IL1.dec -> context
    val extend_many : context -> IL1.dec list -> context

    val lookup_convar : context -> IL1.convar -> IL1.kind option
    val lookup_modvar : context -> IL1.modvar -> IL1.signat option
    val lookup_expvar : context -> IL1.expvar -> IL1.con option

    val sdecs_lookup_conlab :
            IL1.module -> IL1.sdec list -> label -> IL1.kind option
    val sdecs_lookup_modlab :
            IL1.module -> IL1.sdec list -> label -> IL1.signat option
    val sdecs_lookup_explab :
            IL1.module -> IL1.sdec list -> label -> IL1.con option

    (* invariant: in a call "sbnds_lookup_*lab modv sbnds lab",
       "modv" is "ModStruct sbnds".  (for uniformity with above.) *)
    val sbnds_lookup_conlab :
            IL1.module -> IL1.sbnd list -> label -> IL1.con option
    val sbnds_lookup_modlab :
            IL1.module -> IL1.sbnd list -> label -> IL1.module option

    val from_decs : IL1.dec list -> context
    val to_decs : context -> IL1.dec list
  end
