structure IL1Examples =
  struct
    open IL1

    local
        val cx_t = Variable.newNamed "t"
        val cx_u = Variable.newNamed "u"
        val ex_x = Variable.newNamed "x"
        val ex_y = Variable.newNamed "y"
        val ex_z = Variable.newNamed "z"
        val ex_f = Variable.newNamed "f"
        val mx_s = Variable.newNamed "s"
    in
      val kind = KndProd [KndSing (TyRecord [(LabRecord "a", tyInt),
                                             (LabRecord "b", tyBool)]),
                          KndType,
                          KndSing tyChar]

      val kindt = KndType
      val kindp = KndProd[KndType, KndType, KndType]
      val kinds = KndSing tyInt

      val con = ConProj (3, ConProd [tyInt, tyChar, tyString, tyBool])

      val conp  = ConProd [tyInt, tyChar, tyString,
                     TyForall (cx_t, KndType, TyArrow (ConVar cx_t, tyInt))]

      val conabs =
          ConAbs (cx_t, KndProd [KndType, kndArrow (KndType, KndType), KndType],
                  ConProj (2, ConVar cx_t))

      val conrec = TyRecord [(LabRecord "n", tyInt),
                      (LabRecord "s", tyString), (LabRecord "c", tyChar)]
      val consum = TySum [(LabSum "n", tyInt),
                      (LabSum "s", tyString), (LabSum "c", tyChar)]

      val conmod = ConModProj
                     (ModStruct [(LabTycon "t", BndCon (cx_t, tyInt)),
                                 (LabExp "x", BndExp (ex_x, exInt 9)),
                                 (LabTycon "u", BndCon (cx_u, tyString)),
                                 (LabExp "y", BndExp (ex_y, exString "times!"))],
                      LabTycon "u",
                      [LabTycon "t", LabExp "x", LabTycon "u", LabExp "y"])
      val exp1 = ExRecordProj
                  (LabRecord "b",
                   ExRecord [(LabRecord "a", exInt 12),
                             (LabRecord "b", exChar #"c"),
                             (LabRecord "c", exString "xyzzy")],
                   [LabRecord "a", LabRecord "b", LabRecord "c"])

      val exp2 = exLam (ex_x,
                        TySum [(LabRecord "None", tyUnit),
                               (LabRecord "Some", tyInt)],
                        tyInt,
                        ExCase (tyInt,
                                ExVar ex_x,
                                [(LabRecord "None", exLam (ex_y, tyUnit, tyInt,
                                                           exInt 0)),
                                 (LabRecord "Some", exLam (ex_y, tyInt, tyInt,
                                                           ExVar ex_y))]))
      val expinj = ExSumInj (TySum [(LabSum "a", tyInt), (LabSum "b", tyChar)],
                      LabSum "a", exInt 17, [LabSum "a", LabSum "b"])

      val expproj = ExRecordProj (LabRecord "5",
                      exProd [exChar #"a", exChar #"b", exChar #"c",
                              exChar #"d", exChar #"e", exChar #"f"],
                      List.tabulate(6, fn x => LabRecord (Int.toString (x + 1))))

      val expmod =
          ExModLet (mx_s,
            ModStruct [(LabTycon "t", BndCon (cx_t, tyInt)),
                       (LabExp "f",
                        BndExp (ex_f, exLam (ex_y, tyInt, tyInt, ExVar ex_y))),
                       (LabExp "x",
                        BndExp (ex_x, ExApp (ExVar ex_f, exInt 5)))],
            ExModProj (ModVar mx_s,
                       LabExp "x",
                       [LabTycon "t", LabExp "f", LabExp "x"]), tyInt)

      local
        val x = Variable.newNamed "x"
        val fac = Variable.newNamed "fac"
        val facvar = ExVar fac
        val xvar = ExVar x
      in
        val expfac =
          ExLet(fac,
                exProj 1 (ExFix[(fac, x, tyInt, tyInt,
                  exIf tyInt (ExBinOp(xvar, Literal.OpEquals, exInt 0), exInt 1,
                        ExBinOp(ExApp(facvar,
                                      ExBinOp(xvar, Literal.OpMinus, exInt 1)),
                                Literal.OpTimes, xvar)))]) 1,
                ExApp(facvar, exInt 6))
      end
      local
          val c_mu = ConMu (cx_t, KndProd [KndType],
                                ConProd [TyArrow (ConProj (1, ConVar cx_t),
                                                  ConProj (1, ConVar cx_t))])
      in
          val exprec = ExUnroll (ExRoll (ConProj (1, c_mu),
                            ExConApp (ExConAbs (cx_u, KndType,
                                                exLam (ex_x, ConVar cx_u,
                                                       ConVar cx_u, ExVar ex_x)),
                                      ConProj (1, c_mu))))
      end
      
      val signat1 =
          SigStruct
              [ (LabTycon "t", DecConKind (cx_t, KndType)),
                (LabExp "x", DecExpCon (ex_x, ConVar cx_t)),
                (LabTycon "u", DecConKind (cx_u, KndSing (tyProd [ConVar cx_t, tyInt]))),
                (LabExp "y", DecExpCon (ex_y, ConVar (cx_u))) ]


      val module1 =
          ModStruct
              [ (LabTycon "t", BndCon (cx_t, tyString)),
                (LabExp "x", BndExp (ex_x, exString "hello")),
                (LabTycon "u", BndCon (cx_u, tyProd [ConVar cx_t, tyInt])),
                (LabExp "y", BndExp (ex_y, exProd [ExVar ex_x, exInt 12])) ]

      val signat2 =
          SigPi (mx_s,
                 SigStruct
                     [(LabTycon "t", DecConKind (cx_t, KndType)),
                      (LabExp "x", DecExpCon (ex_x, ConVar cx_t)),
                      (LabExp "f", DecExpCon (ex_f, TyArrow (ConVar cx_t,
                                                             tyInt)))],
                 SigStruct
                     [(LabExp "y", DecExpCon (ex_y, tyInt))])

      val module2 =
          ModAbs (mx_s,
                  SigStruct
                      [(LabTycon "t", DecConKind (cx_t, KndType)),
                       (LabExp "x", DecExpCon (ex_x, ConVar cx_t)),
                       (LabExp "f", DecExpCon (ex_f, TyArrow (ConVar cx_t,
                                                              tyInt)))],
                  ModStruct
                      [(LabExp "y",
                        BndExp (ex_y,
                                ExApp (ExModProj (ModVar mx_s,
                                                  LabExp "f",
                                                  [LabTycon "t",
                                                   LabExp "x",
                                                   LabExp "f"]),
                                       ExModProj (ModVar mx_s, LabExp "x",
                                                  [LabTycon "t",
                                                   LabExp "x",
                                                   LabExp "f"]))))])
    local val mx = Variable.newNamed "str1"
          val mx2 = Variable.newNamed "str2"
          val xx = Variable.newNamed "xx"
          val cx = Variable.newNamed "a"
          val xx' = Variable.newNamed "xx'"
          val cx' = Variable.newNamed "a'"
          val cx2 = Variable.newNamed "b"
          val cx2' = Variable.newNamed "b'"
      in
        val module3 =
          ModLet (mx, ModConstrain
                      (ModStruct
                          [(LabModule "M", BndMod (mx2,
                              ModStruct [(LabExp "x", BndExp (xx, exInt 23)),
                                         (LabTycon "t", BndCon (cx, tyInt))]))],
                       SigStruct
                          [(LabModule "M", DecModSig (mx2,
                              SigStruct [(LabExp "x",
                                              DecExpCon (xx', tyInt)),
                                         (LabTycon "t",
                                              DecConKind (cx', KndType))]))]),
                  ModStruct [(LabTycon "u", BndCon (cx2,
                              ConModProj (ModModProj
                                           (ModVar mx,
                                            LabModule "M",
                                            [LabModule "M"]),
                                          LabTycon "t",
                                          [LabExp "x",
                                           LabTycon "t"])))],
                  SigStruct [(LabTycon "u", DecConKind (cx2', KndType))])
      end
      val kind_tests = [kind, kindt, kindp, kinds]
      val con_tests = [con, conp, conabs, conrec, consum, conmod]
      val exp_tests = [exp1, exp2, expinj, expproj, expmod, exprec, expfac]
      val signat_tests = [signat1, signat2]
      val module_tests = [module1, module2, module3]
    end
  end
